/****************************************************************************

    This file is part of The Newtonator soft synth.

    Copyright (C) 2010-2011 Michael Bechard <mbechard@users.sourceforge.net>

    The Newtonator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    The Newtonator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Newtonator.  If not, see <http://www.gnu.org/licenses/>.

****************************************************************************/

#include "CachedPrecomputed.h"

using namespace stk;

CachedPrecomputed::CachedPrecomputed()
{
    _param1 = 0;
    _param2 = 0;
    _param3 = 0;
    _return = 0;
}

CachedPrecomputed::CachedPrecomputed(StkFloat param1, StkFloat param2, StkFloat param3, StkFloat ret)
{
    _param1 = param1;
    _param2 = param2;
    _param3 = param3;
    _return = ret;
}

CachedPrecomputed::~CachedPrecomputed()
{
    //dtor
}

StkFloat CachedPrecomputed::Compute(StkFloat param1, StkFloat param2, StkFloat param3)
{
    if (param1 != _param1 || param2 != _param2 || param3 != _param3)
    {
        _param1 = param1;
        _param2 = param2;
        _param3 = param3;
        _return = RunComputation(_param1, _param2, _param3);
    }

    return _return;
}
