/****************************************************************************

    This file is part of The Newtonator soft synth.

    Copyright (C) 2010-2011 Michael Bechard <mbechard@users.sourceforge.net>

    The Newtonator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    The Newtonator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Newtonator.  If not, see <http://www.gnu.org/licenses/>.

****************************************************************************/

#include "newt_lv2_voice.h"

class NewtonatorInstr : public LV2::Synth<NewtonatorVoice, NewtonatorInstr>
{
    public:
    typedef LV2::Synth<NewtonatorVoice, NewtonatorInstr> SynthClass;

    NewtonatorInstr(double sr);

    unsigned find_free_voice(unsigned char key, unsigned char velocity);
    void handle_midi(uint32_t size, unsigned char* data);

    static const int DEFAULT_NUM_VOICES;

    protected:
    int getNumVoices();
    void doPitchBend(stk::StkFloat midiVal);
};




